local flag = require("flag")

local object = {}

-- Civilization Advances
-- recommended key prefix 'a'
--
object.aAirWarfareIII		= civ.getTech(0)
object.aEducation		= civ.getTech(1)
object.AmphibiousForces		= civ.getTech(2)
object.aAlliance		= civ.getTech(3)
object.aAtomicWeapons		= civ.getTech(4)
object.aAmericanIndustry	= civ.getTech(5)
object.aBushidoDoctrine		= civ.getTech(6)
object.aPublicWorks		= civ.getTech(7)
object.aHeavyCailbreGuns	= civ.getTech(8)
object.aMassMedia		= civ.getTech(9)
object.aSubmarineWarfare	= civ.getTech(10)
object.aEmpireTroops		= civ.getTech(11)
object.aColonialism		= civ.getTech(12)
object.aAirborneWarfare		= civ.getTech(13)
object.aAutomobiles		= civ.getTech(14)
object.aCommunism		= civ.getTech(15)
object.aCodebreaking		= civ.getTech(16)
object.aConscription		= civ.getTech(17)
object.aFortifications		= civ.getTech(18)
object.aModernFinance		= civ.getTech(19)
object.aRegionalCommerce	= civ.getTech(20)
object.aDemocracy		= civ.getTech(21)
object.aEconomicNetworks	= civ.getTech(22)
object.aAeronautics		= civ.getTech(23)
object.aAmericanCulture 	= civ.getTech(24)
object.aShockArmies		= civ.getTech(25)
object.aReconstruction		= civ.getTech(26)
object.aAmerikaBomber		= civ.getTech(27)
object.aEngineerCorps		= civ.getTech(28)
object.aFascism			= civ.getTech(29)
object.aAirWarfareII		= civ.getTech(30)
object.aFanaticism		= civ.getTech(31)
object.aFastBombers		= civ.getTech(32)
object.aReplacementArmy		= civ.getTech(33)
object.aPartisanWarfare		= civ.getTech(34)
object.aGunnery			= civ.getTech(35)
object.aAmphibiousCraft		= civ.getTech(36)
object.aAsianCulture		= civ.getTech(37)
object.aEuropeanCulture		= civ.getTech(38)
object.aSelfPropelledGuns	= civ.getTech(39)
object.aIndustrialization	= civ.getTech(40)
object.aLuftwaffe		= civ.getTech(41)
object.aMobileWarfare		= civ.getTech(42)
object.aMilitaryResearch	= civ.getTech(43)
object.aMobileAAArtillery	= civ.getTech(44)
object.aAAEscortVessels		= civ.getTech(45)
object.aShipbuilding		= civ.getTech(46)
object.aModernInfantry		= civ.getTech(47)
object.aMassProduction		= civ.getTech(48)
object.aMilitarism		= civ.getTech(49)
object.aLendLease		= civ.getTech(50)
object.aRocketArtillery		= civ.getTech(51)
object.aTotalWarIndustry	= civ.getTech(52)
object.aMobileWarfareIII	= civ.getTech(53)
object.aImperialism		= civ.getTech(54)
object.aReligion		= civ.getTech(55)
object.aPopularCulture		= civ.getTech(56)
object.aCarrierOperations	= civ.getTech(57)
object.aNuclearFission		= civ.getTech(58)
object.aRoyalNavy		= civ.getTech(59)
object.aEuropeanScience		= civ.getTech(60)
object.aRoyalAirForce		= civ.getTech(61)
object.aD3AReplacement		= civ.getTech(62)
object.aPanzerDestroyer		= civ.getTech(63)
object.aASWOperations		= civ.getTech(64)
object.aLargeBattleships	= civ.getTech(65)
object.aAirWarfare		= civ.getTech(66)
object.aModernRailroads		= civ.getTech(67)
object.aRedArmy			= civ.getTech(68)
object.aReserveFront		= civ.getTech(69)
object.aFactoryFarming		= civ.getTech(70)
object.aRepublic		= civ.getTech(71)
object.aJagdbomber		= civ.getTech(72)
object.aRocketry		= civ.getTech(73)
object.aSanitation		= civ.getTech(74)
object.aSeaPower		= civ.getTech(75)
object.aStrategicBombing	= civ.getTech(76)
object.aJetFlight		= civ.getTech(77)
object.aSovietGuards		= civ.getTech(78)
object.aAAArtillery		= civ.getTech(79)
object.aSuperbomber		= civ.getTech(80)
object.aMobileWarfareII		= civ.getTech(81)
object.aChristianity		= civ.getTech(82)
object.aKamikazeWeapons		= civ.getTech(83)
object.aRailTransportation	= civ.getTech(84)
object.aAtomicResearch		= civ.getTech(85)
object.aBlitzkrieg		= civ.getTech(86)
object.aWunderwaffe		= civ.getTech(87)
object.aOfficerTraining		= civ.getTech(88)
object.aAutonomousResearch 	= civ.getTech(89)
object.aGerRussianCampaign	= civ.getTech(90)
object.aGerAfricanCampaign	= civ.getTech(91)
object.aGerBritishCampaign	= civ.getTech(92)
object.aSovEuropeanFront	= civ.getTech(93)
object.aSovAsianFront           = civ.getTech(94)
object.aJapPacificCampaign	= civ.getTech(95)
object.aAlliedAfricanInvasion	= civ.getTech(96)
object.aAlliedItalianInvasion 	= civ.getTech(97)
object.aAlliedEuropeanInvasion 	= civ.getTech(98)
object.aAlliedNordicInvasion    = civ.getTech(99)




-- Map Locations (tiles/squares)
-- recommended key prefix 'l'



-- Cities
-- recommended key prefix 'c'
-- It is not recommended to put cities into this list if the city
-- can be destroyed. This list returns an error if 'nil' is the value
-- associated with the key (see bottom of file), so that could cause
-- a problem if a city in this list is destroyed.  Also, if another
-- city is founded, the ID number of the city might get reused, causing
-- more confusion.  An alternate way to reference a city is by using
-- object.lRome.city when you actually need the city (and suitably guarding
-- against nil values)

--Find these by entering "for city in civ.iterateCities() do print(city.id, city.name) end" in the console



-- Unit Types
-- recommended key prefix 'u'
object.uWorkers				= civ.getUnitType(0)
object.uEngineers			= civ.getUnitType(1)
object.uRedArmy 			= civ.getUnitType(2)
object.uRedArmyII			= civ.getUnitType(3)
object.uShockTroops			= civ.getUnitType(4)
object.uAirborneTroops			= civ.getUnitType(5)
object.uRedArmyGuards			= civ.getUnitType(6)
object.uImperialArmy			= civ.getUnitType(7)
object.uAssaultTroops			= civ.getUnitType(8)
object.uPartisans			= civ.getUnitType(9)
object.uIJAParatroops			= civ.getUnitType(10)
object.uSNLFMarines			= civ.getUnitType(11)
object.uGrenadiers			= civ.getUnitType(12)
object.uGrenadiersII			= civ.getUnitType(13)
object.uFallschirmjagers		= civ.getUnitType(14)
object.uWaffenSS			= civ.getUnitType(15)
object.uItalianArmy			= civ.getUnitType(16)
object.uFinnishArmy			= civ.getUnitType(17)
object.uRomanianArmy			= civ.getUnitType(18)
object.uVichyArmy			= civ.getUnitType(19)
object.uSpanishArmy			= civ.getUnitType(20)
object.uDutchArmy			= civ.getUnitType(21)
object.uGarrison			= civ.getUnitType(22)
object.uMuslimArmy			= civ.getUnitType(23)
object.uColonialRifles			= civ.getUnitType(24)
object.uUSArmy				= civ.getUnitType(25)
object.uUSArmyII			= civ.getUnitType(26)
object.uUSAirborne			= civ.getUnitType(27)
object.uUSMarines			= civ.getUnitType(28)
object.uInfantry			= civ.getUnitType(29)
object.uInfantryII			= civ.getUnitType(30)
object.uParatroopers			= civ.getUnitType(31)
object.uCommandos			= civ.getUnitType(32)
object.uGurkhas				= civ.getUnitType(33)
object.uAnzacs				= civ.getUnitType(34)
object.uCanadianArmy			= civ.getUnitType(35)
object.uKMTArmy				= civ.getUnitType(36)
object.uKMTArmyII			= civ.getUnitType(37)
object.uPLATroops			= civ.getUnitType(38)
object.uArtillery			= civ.getUnitType(39)
object.uHeavyArtillery			= civ.getUnitType(40)
object.uMobileArtillery			= civ.getUnitType(41)
object.uAABattery			= civ.getUnitType(42)
object.uAABatteryII			= civ.getUnitType(43)
object.uV2Missile			= civ.getUnitType(44)
object.uAtomBomb			= civ.getUnitType(45)
object.uGeneral				= civ.getUnitType(46)
object.uKatyusha			= civ.getUnitType(47)
object.uMRLTruck			= civ.getUnitType(48)
object.uTradeTruck			= civ.getUnitType(49)
object.uArmoredInfantry			= civ.getUnitType(50)
object.uPanzergrenadiers		= civ.getUnitType(51)
object.uLightTank			= civ.getUnitType(52)
object.uMediumTank			= civ.getUnitType(53)
object.uFighter				= civ.getUnitType(54)
object.uJetFighter			= civ.getUnitType(55)
object.uBomber				= civ.getUnitType(56)
object.uAlliedHeavyBomber		= civ.getUnitType(57)
object.uAxisHeavyBomber			= civ.getUnitType(58)
object.uFreighter			= civ.getUnitType(59)
object.uLiner				= civ.getUnitType(60)
object.uLibertyShip			= civ.getUnitType(61)
object.uDestroyer			= civ.getUnitType(62)
object.uCruiser				= civ.getUnitType(63)
object.uAACruiser			= civ.getUnitType(64)
object.uAACruiserII			= civ.getUnitType(65)
object.uBattleship			= civ.getUnitType(66)
object.uSuperBattleship			= civ.getUnitType(67)
object.uAircraftCarrier			= civ.getUnitType(68)
object.uEscortCarrier			= civ.getUnitType(69)
object.uSubmarine			= civ.getUnitType(70)
object.uSubmarineII			= civ.getUnitType(71)
object.uI16				= civ.getUnitType(72)
object.uLa5				= civ.getUnitType(73)
object.uYak3				= civ.getUnitType(74)
object.uIl2Sturmovik			= civ.getUnitType(75)
object.uTB3				= civ.getUnitType(76)
object.uA6MZero				= civ.getUnitType(77)
object.uKi61Hien			= civ.getUnitType(78)
object.uKi84Hayate			= civ.getUnitType(79)
object.uD3A				= civ.getUnitType(80)
object.uD4YSuisei			= civ.getUnitType(81)
object.uKi67Hiryu			= civ.getUnitType(82)
object.uMXY7Ohka			= civ.getUnitType(83)
object.uBf109				= civ.getUnitType(84)
object.uFw190				= civ.getUnitType(85)
object.uMe262Schwalbe			= civ.getUnitType(86)
object.uJu87Stuka			= civ.getUnitType(87)
object.uHs129			 	= civ.getUnitType(88)
object.uJu88				= civ.getUnitType(89)
object.uJu390				= civ.getUnitType(90)
object.uAVGWarhawk			= civ.getUnitType(91)
object.uP38Lightning			= civ.getUnitType(92)
object.uP47Thunderbolt			= civ.getUnitType(93)
object.uP51Mustang			= civ.getUnitType(94)
object.uP80ShootingStar			= civ.getUnitType(95)
object.uF6FHellcat			= civ.getUnitType(96)
object.uB17Fortress			= civ.getUnitType(97)
object.uB29SuperFortress		= civ.getUnitType(98)
object.uHurricane			= civ.getUnitType(99)
object.uSpitfire			= civ.getUnitType(100)
object.uTempest				= civ.getUnitType(101)
object.uMeteor				= civ.getUnitType(102)
object.uMosquito			= civ.getUnitType(103)
object.uLancaster			= civ.getUnitType(104)
object.uT34				= civ.getUnitType(105)
object.uT3485				= civ.getUnitType(106)
object.uKV1				= civ.getUnitType(107)
object.uIS2				= civ.getUnitType(108)
object.uGuardsT34			= civ.getUnitType(109)
object.uType97ChiHa			= civ.getUnitType(110)
object.uType3ChiNu			= civ.getUnitType(111)
object.uType5ChiRi			= civ.getUnitType(112)
object.uPzKpfwIII			= civ.getUnitType(113)
object.uPzKpfwIV			= civ.getUnitType(114)
object.uPzKpfwVPanther			= civ.getUnitType(115)
object.uPzKpfwVITiger			= civ.getUnitType(116)
object.uUSMCLVT				= civ.getUnitType(117)
object.uM3Lee				= civ.getUnitType(118)
object.uM4Sherman			= civ.getUnitType(119)
object.uM26Pershing			= civ.getUnitType(120)
object.uValentine			= civ.getUnitType(121)
object.uChurchill			= civ.getUnitType(122)
object.uComet				= civ.getUnitType(123)
object.uCenturion			= civ.getUnitType(124)



-- City Improvements
-- recommended key prefix 'i'
--          
object.iNothing			= civ.getImprovement(0)
object.iCapital			= civ.getImprovement(1)
object.iBarracks		= civ.getImprovement(2)
object.iWarehouses		= civ.getImprovement(3)
object.iPropaganda		= civ.getImprovement(4)
object.iLocalIndustry		= civ.getImprovement(5)
object.iPublicSchool		= civ.getImprovement(6)
object.iGovernor		= civ.getImprovement(7)
object.iCityDefences		= civ.getImprovement(8)
object.iModernSewer		= civ.getImprovement(9)
object.iFreightDepot		= civ.getImprovement(10)
object.iChurch			= civ.getImprovement(11)
object.iOfficerAcademy		= civ.getImprovement(12)
--MassTransit			= civ.getImprovement(13)
object.iCinema			= civ.getImprovement(14)
object.iMilitaryFactory		= civ.getImprovement(15)
object.iAssemblyLine		= civ.getImprovement(16)
object.iWasserfallBattery	= civ.getImprovement(17)
--RecyclingCenter		= civ.getImprovement(18)
object.iTankFactory		= civ.getImprovement(19)
--HydroPlant			= civ.getImprovement(20)
object.iArmamentsPlant		= civ.getImprovement(21)
object.iFinancialDistrict	= civ.getImprovement(22)
object.iModernHousing		= civ.getImprovement(23)
object.iVictoryFarm		= civ.getImprovement(24)
object.iRailStation		= civ.getImprovement(25)
object.iResearchFacility	= civ.getImprovement(26)
object.iAABattery		= civ.getImprovement(27)
object.iCoastalBattery		= civ.getImprovement(28)
--SolarPlant			= civ.getImprovement(29)
object.iDocks			= civ.getImprovement(30)
object.iShipyard		= civ.getImprovement(31)
object.iAirbase			= civ.getImprovement(32)
object.iMilitaryPolice		= civ.getImprovement(33)
object.iNavalBase		= civ.getImprovement(34)
--object.iTransporter		= civ.getImprovement(35)
--object.iStructural		= civ.getImprovement(35)
--object.iComponent		= civ.getImprovement(35)
--object.iModule		= civ.getImprovement(35)
--object.iAutonomousCity	= civ.getImprovement(35)



-- Tribes
-- recommended key prefix 't'
--
object.tRebels			= civ.getTribe(0)
object.tRussians		= civ.getTribe(1)
object.tJapanese		= civ.getTribe(2)
object.tGermans			= civ.getTribe(3)
object.tNeutrals		= civ.getTribe(4)
object.tAmericans		= civ.getTribe(5)
object.tBritish			= civ.getTribe(6)
object.tChinese			= civ.getTribe(7)



-- Wonders
-- recommended key prefix 'w'
object.wRepublicofChina		= civ.getWonder(0)
object.wBuckinghamPalace	= civ.getWonder(1)
object.wSuezCanal		= civ.getWonder(2)
object.wPortofTokyo		= civ.getWonder(3)
object.wForeignAffairsMinistry	= civ.getWonder(4)
object.wHollywood		= civ.getWonder(5)
object.wCityofConstantinople	= civ.getWonder(6)
object.wGermanHighCommand	= civ.getWonder(7)
object.wNationalShipyard	= civ.getWonder(8)
object.wReichChancellery	= civ.getWonder(9)
object.wTheKremlin		= civ.getWonder(10)
object.wPeenemundeFacility	= civ.getWonder(11)
object.wClydeShipyards		= civ.getWonder(12)
object.wPekingCity		= civ.getWonder(13)
--LeonardosWorkshop		= civ.getWonder(14)
object.wImperialPalace		= civ.getWonder(15)
object.wAtomicResearchLab	= civ.getWonder(16)
object.wCityofLondon		= civ.getWonder(17)
object.wSecretWeaponsProgram	= civ.getWonder(18)
object.wStatueofLiberty		= civ.getWonder(19)
object.wEiffelTower		= civ.getWonder(20)
object.wWhiteHouse		= civ.getWonder(21)
--HooverDam			= civ.getWonder(22)
object.wManhattanProject	= civ.getWonder(23)
object.wInternationalBankers	= civ.getWonder(24)
object.wCodeDecryptionOffice	= civ.getWonder(25)
object.wNuclearReactor		= civ.getWonder(26)
object.wKMTHeadquarters		= civ.getWonder(27)


--

--Text
-- 

-- Flag and Counter Definitions
-- Flags and counters have to be defined somewhere, and this is as good a place as any.

-- this will give you an if you try to access a key not entered into
-- the object table, which could be helpful for debugging, but it
-- means that no nil value can ever be returned for table object
-- If you need that ability, comment out this section
setmetatable(object,{__index = function(myTable,key)
    error("The object table doesn't have a value associated with "..tostring(key)..".") end})

return object
